/*

      This file contains 42 uppercase characters.
      Characters are generally sized 4*5*1.
      Character bottom is at Y=0 and is centered to origin.

      Produced by Timo Ettanen  tket@spider.compart.fi

*/

#version 3.0

#declare Schar_A =
merge{
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,3,0>}
    plane{y,3}
  }
  cylinder{<-1.5,0.5,0><-1.5,3.001,0>,0.5}
  cylinder{< 1.5,0.5,0>< 1.5,3.001,0>,0.5}
  cylinder{<-1.5,2.5,0>< 1.5,2.5,0>,0.5}
  sphere{<-1.5,0.5,0>,0.5}
  sphere{< 1.5,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_B =
merge{
  difference{
    torus{1,0.5 rotate<90,0,0> translate<0,3.5,0>}
    plane{x,0}
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate<0.5,1.5,0>}
    plane{x,0.5}
  }
  cylinder{<-1.5,0.5,0><-1.5,4.5,0>,0.5}
  cylinder{<-1.5,4.5,0>< 0.001,4.5,0>,0.5}
  cylinder{<-1.5,2.5,0>< 0.501,2.5,0>,0.5}
  cylinder{<-1.5,0.5,0>< 0.501,0.5,0>,0.5}
  sphere{< -1.5,0.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_C =
merge{
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,3,0>}
    plane{y,3}
    plane{y,0 rotate z*45 translate y*3}
  }
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,2,0>}
    plane{y,2 inverse}
    plane{y,0 rotate z*-45 translate y*2 inverse}
  }
  cylinder{<-1.5,1.999,0><-1.5,3.001,0>,0.5}
  sphere{<1.5,0,0>,0.5 rotate z*45 translate y*3}
  sphere{<1.5,0,0>,0.5 rotate z*-45 translate y*2}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_D =
merge{
  intersection{
    torus{1.5,0.5 rotate<90,0,0> translate<0,3,0>}
    box{<0,3,-0.501><2.001,5.001,0.501>}
  }
  intersection{
    torus{1.5,0.5 rotate<90,0,0> translate<0,2,0>}
    box{<0,-0.001,-0.501><2.001,2.001,0.501>}
  }
  cylinder{<-1.5,0.5,0><-1.5,4.5,0>,0.5}
  cylinder{<-1.5,4.5,0>< 0.001,4.5,0>,0.5}
  cylinder{< 1.5,3.001,0>< 1.5,1.999,0>,0.5}
  cylinder{<-1.5,0.5,0>< 0.001,0.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  sphere{< -1.5,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_E =
merge{
  cylinder{<-1.5,0.5,0><-1.5,4.5,0>,0.5}
  cylinder{<-1.5,4.5,0>< 1.5,4.5,0>,0.5}
  cylinder{<-1.5,2.5,0>< 0.5,2.5,0>,0.5}
  cylinder{<-1.5,0.5,0>< 1.5,0.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  sphere{<  1.5,4.5,0>,0.5}
  sphere{<  0.5,2.5,0>,0.5}
  sphere{<  1.5,0.5,0>,0.5}
  sphere{< -1.5,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_F =
merge{
  cylinder{<-1.5,0.5,0><-1.5,4.5,0>,0.5}
  cylinder{<-1.5,4.5,0>< 1.5,4.5,0>,0.5}
  cylinder{<-1.5,2.5,0>< 0.5,2.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  sphere{<  1.5,4.5,0>,0.5}
  sphere{<  0.5,2.5,0>,0.5}
  sphere{< -1.5,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_G =
merge{
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,3,0>}
    plane{y,3}
    plane{y,0 rotate z*45 translate y*3}
  }
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,2,0>}
    plane{y,2 inverse}
  }
  cylinder{<-1.5,1.999,0><-1.5,3.001,0>,0.5}
  cylinder{< 0,2,0>< 1.5,2,0>,0.5}
  sphere{<0,2,0>,0.5}
  sphere{<1.5,2,0>,0.5}
  sphere{<1.5,0,0>,0.5 rotate z*45 translate y*3}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_H =
merge{
  cylinder{<-1.5,0.5,0><-1.5,4.5,0>,0.5}
  cylinder{<-1.5,2.5,0>< 1.5,2.5,0>,0.5}
  cylinder{< 1.5,0.5,0>< 1.5,4.5,0>,0.5}
  sphere{< -1.5,0.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  sphere{<  1.5,0.5,0>,0.5}
  sphere{<  1.5,4.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_I =
merge{
  cylinder{<0,4.5,0><0,0.5,0>,0.5}
  sphere{< 0,4.5,0>,0.5}
  sphere{< 0,0.5,0>,0.5}
  bounded_by{ box { <-0.5,0,-.5>,<0.5,5,0.5> } }
}

#declare Schar_J =
merge{
  difference{
    torus{1,0.5 rotate<90,0,0> translate<0,1.5,0>}
    plane{y, 1.5 inverse}
    plane{y,0 rotate z*45 translate y*1.5 inverse}
  }
  cylinder{< 1,1.499,0>< 1,4.5,0>,0.5}
  sphere{< 1,4.5,0>,0.5 }
  sphere{< 0,-1,0>,0.5 rotate z*-45 translate y*1.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_K =
merge{
  cylinder{<-1.5,0.5,0><-1.5,4.5,0>,0.5}
  difference{
    cylinder{< 1.5,4.5,0><-2,1,0>,0.5}
    plane{x,-1.5}
  }
  difference{
    cylinder{< 1.5,0.5,0><-1.5,4.5,0>,0.5}
    plane{y,0 rotate z*45 translate y*3 inverse}
  }
  sphere{< -1.5,0.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  sphere{< 1.5,4.5,0>,0.5}
  sphere{< 1.5,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_L =
merge{
  cylinder{<-1.5,0.5,0><-1.5,4.5,0>,0.5}
  cylinder{<-1.5,0.5,0>< 1.5,0.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  sphere{<  1.5,0.5,0>,0.5}
  sphere{< -1.5,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_M =
merge{
  cylinder{<-1.5,0.5,0><-1.5,4.5,0>,0.5}
  cylinder{<-1.5,4.5,0><0,2.5,0>,0.5}
  cylinder{< 1.5,4.5,0><0,2.5,0>,0.5}
  cylinder{< 1.5,0.5,0>< 1.5,4.5,0>,0.5}
  sphere{< -1.5,0.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  sphere{< 0,2.5,0>,0.5}
  sphere{< 1.5,4.5,0>,0.5}
  sphere{< 1.5,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_N =
merge{
  cylinder{<-1.5,0.5,0><-1.5,4.5,0>,0.5}
  cylinder{<-1.5,4.5,0>< 1.5,0.5,0>,0.5}
  cylinder{< 1.5,0.5,0>< 1.5,4.5,0>,0.5}
  sphere{< -1.5,0.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  sphere{<  1.5,0.5,0>,0.5}
  sphere{<  1.5,4.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_O =
merge{
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,3,0>}
    plane{y,3}
  }
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,2,0>}
    plane{y,2 inverse}
  }
  cylinder{<-1.5,1.999,0><-1.5,3.001,0>,0.5}
  cylinder{< 1.5,1.999,0>< 1.5,3.001,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_P =
merge{
  difference{
    torus{1,0.5 rotate<90,0,0> translate<0,3.5,0>}
    plane{x,0}
  }
  cylinder{<-1.5,0.5,0><-1.5,4.5,0>,0.5}
  cylinder{<-1.5,4.5,0>< 0.001,4.5,0>,0.5}
  cylinder{<-1.5,2.5,0>< 0.001,2.5,0>,0.5}
  sphere{< -1.5,0.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_Q =
merge{
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,3,0>}
    plane{y,3}
  }
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,2,0>}
    plane{y,2 inverse}
  }
  cylinder{<-1.5,1.999,0><-1.5,3.001,0>,0.5}
  cylinder{< 1.5,1.999,0>< 1.5,3.001,0>,0.5}
  cylinder{< 1.5,0.5,0>< 0.5,1.5,0>,0.5}
  sphere{< 1.5,0.5,0>,0.5}
  sphere{< 0.5,1.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_R =
merge{
  difference{
    torus{1,0.5 rotate<90,0,0> translate<0,3.5,0>}
    plane{x,0}
  }
  difference{
    cylinder{< 1.0,0.5,0>< -0.5,2.5,0>,0.5}
    plane{y,2.5 inverse}
  }
  cylinder{<-1.5,0.5,0><-1.5,4.5,0>,0.5}
  cylinder{<-1.5,4.5,0>< 0.001,4.5,0>,0.5}
  cylinder{<-1.5,2.5,0>< 0.001,2.5,0>,0.5}
  sphere{< -1.5,0.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  sphere{<  1.0,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_S =
merge{
  difference{
    torus{1,0.5 rotate<90,0,0> translate<-0.5,3.5,0>}
    plane{x,-0.5 inverse}
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate< 0.5,1.5,0>}
    plane{x,0.5 }
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate<-0.5,1.5,0>}
    plane{x,-0.5 inverse}
    plane{x,0 rotate z*-45 translate x*-2}
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate< 0.5,3.5,0>}
    plane{x,0.5 }
    plane{x,0 rotate z*-45 translate<0.5,3.5,0> inverse}
  }
  cylinder{<-0.501,2.5,0>< 0.501,2.5,0>,0.5}
  cylinder{<-0.501,4.5,0>< 0.501,4.5,0>,0.5}
  cylinder{<-0.501,0.5,0>< 0.501,0.5,0>,0.5}
  sphere{< 0, 1,0>,0.5 rotate z*-45 translate<0.5,3.5,0> }
  sphere{< 0,-1,0>,0.5 rotate z*-45 translate<-0.5,1.5,0>}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_T =
merge{
  cylinder{<-1.5,4.5,0><1.5,4.5,0>,0.5}
  cylinder{<0,4.5,0><0,0.5,0>,0.5}
  sphere{<-1.5,4.5,0>,0.5}
  sphere{< 1.5,4.5,0>,0.5}
  sphere{< 0,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_U =
merge{
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,2,0>}
    plane{y,2 inverse}
  }
  cylinder{<-1.5,4.5,0><-1.5,1.999,0>,0.5}
  cylinder{< 1.5,4.5,0>< 1.5,1.999,0>,0.5}
  sphere{<-1.5,4.5,0>,0.5}
  sphere{< 1.5,4.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_V =
merge{
  cylinder{<-1.5,4.5,0><0,0.5,0>,0.5}
  cylinder{< 1.5,4.5,0><0,0.5,0>,0.5}
  sphere{<-1.5,4.5,0>,0.5}
  sphere{< 0,0.5,0>,0.5}
  sphere{< 1.5,4.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_W =
merge{
  cylinder{<-1.5,0.5,0><-1.5,4.5,0>,0.5}
  cylinder{<-1.5,0.5,0><0,2.5,0>,0.5}
  cylinder{< 1.5,0.5,0><0,2.5,0>,0.5}
  cylinder{< 1.5,0.5,0>< 1.5,4.5,0>,0.5}
  sphere{< -1.5,0.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  sphere{< 0,2.5,0>,0.5}
  sphere{< 1.5,4.5,0>,0.5}
  sphere{< 1.5,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_X =
merge{
  cylinder{<-1.5,0.5,0>< 1.5,4.5,0>,0.5}
  cylinder{<-1.5,4.5,0>< 1.5,0.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  sphere{<  1.5,4.5,0>,0.5}
  sphere{<  1.5,0.5,0>,0.5}
  sphere{< -1.5,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_Y =
merge{
  cylinder{<-1.5,4.5,0><0,3,0>,0.5}
  cylinder{< 1.5,4.5,0><0,3,0>,0.5}
  cylinder{< 0,0.5,0><0,3,0>,0.5}
  sphere{<-1.5,4.5,0>,0.5}
  sphere{< 0,0.5,0>,0.5}
  sphere{< 1.5,4.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_Z =
merge{
  cylinder{<-1.5,0.5,0>< 1.5,4.5,0>,0.5}
  cylinder{<-1.5,4.5,0>< 1.5,4.5,0>,0.5}
  cylinder{<-1.5,0.5,0>< 1.5,0.5,0>,0.5}
  sphere{< -1.5,4.5,0>,0.5}
  sphere{<  1.5,4.5,0>,0.5}
  sphere{<  1.5,0.5,0>,0.5}
  sphere{< -1.5,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_scand1 =
merge{
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,3,0>}
    plane{y,3}
  }
  torus{0.5,0.5 rotate x*90 translate y*5.5}
  cylinder{<-1.5,0.5,0><-1.5,3.001,0>,0.5}
  cylinder{< 1.5,0.5,0>< 1.5,3.001,0>,0.5}
  cylinder{<-1.5,2.5,0>< 1.5,2.5,0>,0.5}
  sphere{<-1.5,0.5,0>,0.5}
  sphere{< 1.5,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,6.5,0.5> } }
}

#declare Schar_scand2 =
merge{
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,3,0>}
    plane{y,3}
  }
  cylinder{<-1.5,0.5,0><-1.5,3.001,0>,0.5}
  cylinder{< 1.5,0.5,0>< 1.5,3.001,0>,0.5}
  cylinder{<-1.5,2.5,0>< 1.5,2.5,0>,0.5}
  sphere{<-1.5,0.5,0>,0.5}
  sphere{< 1.5,0.5,0>,0.5}
  sphere{<-1,5.5,0>,0.5}
  sphere{< 1,5.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,6,0.5> } }
}

#declare Schar_scand3 =
merge{
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,3,0>}
    plane{y,3}
  }
  difference{
    torus{1.5,0.5 rotate<90,0,0> translate<0,2,0>}
    plane{y,2 inverse}
  }
  cylinder{<-1.5,1.999,0><-1.5,3.001,0>,0.5}
  cylinder{< 1.5,1.999,0>< 1.5,3.001,0>,0.5}
  sphere{<-1,5.5,0>,0.5}
  sphere{< 1,5.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,6,0.5> } }
}

#declare Schar_1 = object{Schar_I}

#declare Schar_2 =
merge{
  difference{
    torus{1,0.5 rotate<90,0,0> translate< 0.5,3.5,0>}
    plane{x, 0.5 }
  }
  intersection{
    torus{1,0.5 rotate<90,0,0> translate<-0.5,1.5,0>}
    box{<-2.001,1.5,-0.501><-0.5,3.001,0.501>}
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate<-0.5,3.5,0>}
    plane{x,-0.5 inverse}
    plane{y,0 rotate z*-45 translate <-0.5,3.5.0>}
  }
  cylinder{<-0.501,2.5,0>< 0.501,2.5,0>,0.5}
  cylinder{<-0.501,4.5,0>< 0.501,4.5,0>,0.5}
  cylinder{<-1.5,0.5,0>< 1.5,0.5,0>,0.5}
  cylinder{<-1.5,0.5,0><-1.5,1.501,0>,0.5}
  sphere{<-1.5,0.5,0>,0.5}
  sphere{< 1.5,0.5,0>,0.5}
  sphere{< 0, 1,0>,0.5 rotate z*45 translate<-0.5,3.5,0> }
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_3 =
merge{
  difference{
    torus{1,0.5 rotate<90,0,0> translate< 0.5,3.5,0>}
    plane{x, 0.5 }
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate< 0.5,1.5,0>}
    plane{x,0.5 }
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate<-0.5,3.5,0>}
    plane{x,-0.5 inverse}
    plane{y,0 rotate z*-45 translate <-0.5,3.5.0>}
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate<-0.5,1.5,0>}
    plane{x,-0.5 inverse}
    plane{x,0 rotate z*-45 translate x*-2}
  }
  cylinder{< 0,2.5,0>< 0.501,2.5,0>,0.5}
  cylinder{<-0.501,4.5,0>< 0.501,4.5,0>,0.5}
  cylinder{<-0.501,0.5,0>< 0.501,0.5,0>,0.5}
  sphere{< 0,2.5,0>,0.5}
  sphere{< 0, 1,0>,0.5 rotate z*45 translate<-0.5,3.5,0> }
  sphere{< 0,-1,0>,0.5 rotate z*-45 translate<-0.5,1.5,0>}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_4 =
merge{
  intersection{
    torus{1,0.5 rotate<90,0,0> translate<-0.5,3.5,0>}
    box{<-2.001,1.999,-0.501><-0.5,3.5,0.501>}
  }
  cylinder{<-0.501,2.5,0>< 1.5,2.5,0>,0.5}
  cylinder{<-1.5,4.5,0><-1.5,3.499,0>,0.5}
  cylinder{< 1,0.5,0>< 1,4.5,0>,0.5}
  sphere{<-1.5,4.5,0>,0.5}
  sphere{< 1,4.5,0>,0.5}
  sphere{< 1,0.5,0>,0.5}
  sphere{< 1.5,2.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_5 =
merge{
  difference{
    torus{1,0.5 rotate<90,0,0> translate< 0.5,1.5,0>}
    plane{x,0.5 }
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate<-0.5,1.5,0>}
    plane{x,-0.5 inverse}
    plane{x,0 rotate z*-45 translate x*-2}
  }
  cylinder{<-1,2.5,0>< 0.501,2.5,0>,0.5}
  cylinder{<-1,4.5,0>< 1,4.5,0>,0.5}
  cylinder{<-0.501,0.5,0>< 0.501,0.5,0>,0.5}
  cylinder{<-1,4.5,0><-1,2.5,0>,0.5}
  sphere{<1,4.5,0>,0.5}
  sphere{<-1,4.5,0>,0.5}
  sphere{<-1,2.5,0>,0.5}
  sphere{< 0,-1,0>,0.5 rotate z*-45 translate<-0.5,1.5,0>}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_6 =
merge{
  intersection{
    torus{1,0.5 rotate<90,0,0> translate<-0.5,3.5,0>}
    box{<-2.001,3.5,-0.501><-0.5,5.001,0.501>}
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate< 0.5,1.5,0>}
    plane{x,0.5 }
  }
  intersection{
    torus{1,0.5 rotate<90,0,0> translate<-0.5,1.5,0>}
    box{<-2.001,-0.001,-0.501><-0.5,1.5,0.501>}
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate< 0.5,3.5,0>}
    plane{x,0.5 }
    plane{x,0 rotate z*-45 translate<0.5,3.5,0> inverse}
  }
  cylinder{<-1.5,2.5,0>< 0.501,2.5,0>,0.5}
  cylinder{<-0.501,4.5,0>< 0.501,4.5,0>,0.5}
  cylinder{<-0.501,0.5,0>< 0.501,0.5,0>,0.5}
  cylinder{<-1.5,1.499,0><-1.5,3.501,0>,0.5}
  sphere{< 0, 1,0>,0.5 rotate z*-45 translate<0.5,3.5,0> }
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_7 =
merge{
  cylinder{<-1.5,4.5,0><1.5,4.5,0>,0.5}
  cylinder{<1.5,4.5,0><-1,0.5,0>,0.5}
  sphere{<-1.5,4.5,0>,0.5}
  sphere{< 1.5,4.5,0>,0.5}
  sphere{< -1,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_8 =
merge{
  difference{
    torus{1,0.5 rotate<90,0,0> translate<-0.5,1.5,0>}
    plane{x,-0.5 inverse}
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate< 0.5,1.5,0>}
    plane{x,0.5 }
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate<-0.5,3.5,0>}
    plane{x,-0.5 inverse}
  }
  difference{
    torus{1,0.5 rotate<90,0,0> translate< 0.5,3.5,0>}
    plane{x,0.5 }
  }
  cylinder{<-0.501,4.5,0>< 0.501,4.5,0>,0.5}
  cylinder{<-0.501,2.5,0>< 0.501,2.5,0>,0.5}
  cylinder{<-0.501,0.5,0>< 0.501,0.5,0>,0.5}
  bounded_by{ box { <-2,0,-.5>,<2,5,0.5> } }
}

#declare Schar_9 =
object{Schar_6 rotate z*180 translate y*5}

#declare Schar_0 = object{Schar_O}

#declare Schar_minus =
merge{
  cylinder{<-1,2.5,0>< 1,2.5,0>,0.5}
  sphere{< -1,2.5,0>,0.5}
  sphere{<  1,2.5,0>,0.5}
  bounded_by{ box { <-1.5,1.999,-.5>,<1.5,3.001,0.5> } }
}

#declare Schar_plus =
merge{
  cylinder{<-1,2.5,0>< 1,2.5,0>,0.5}
  cylinder{<0,1.5,0>< 0,3.5,0>,0.5}
  sphere{<-1,2.5,0>,0.5}
  sphere{< 1,2.5,0>,0.5}
  sphere{< 0,1.5,0>,0.5}
  sphere{< 0,3.5,0>,0.5}
  bounded_by{ box { <-1.5,1,-.5>,<1.5,4,0.5> } }
}

#declare Schar_dot =
  sphere{<0,0.5,0>,0.5}
